/*
  CPP_CONTEST=2018Enero
  CPP_PROBLEM=B
  CPP_LANG=CPP+MPI
  CPP_PROCESSES_PER_NODE=calisto 1
*/

#include <stdlib.h>
#include <mpi.h>

extern void escribir(int *,int,int);

void filapar(int n,int *A,int *B)
{
  B[0]=(A[-n]+A[0]+A[1]+A[n])/5; //casilla izquierda
  for(int i=1;i<n-1;i++) //casillas no extremas de la fila
    B[i]=(A[i-n]+A[i-1]+A[i]+A[i+1]+A[i+n])/5;
  B[n-1]=(A[-1]+A[n-2]+A[n-1]+A[2*n-1])/5; //casilla derecha
}

void filaimpar(int n,int *A,int *B)
{
  B[0]=(A[-n+1]+A[0]+A[n+1])/5; //casilla izquierda
  for(int i=1;i<n-1;i++) //casillas no extremas de la fila
    B[i]=(A[i-n-1]+A[i-n+1]+A[i]+A[i+n-1]+A[i+n+1])/5;
  B[n-1]=(A[-2]+A[n-1]+A[2*n-2])/5; //casilla derecha
}

void par(int n,int *A,int *B)
{
  B[0]=(A[0]+A[1]+A[n])/5; //casilla superior-izquierda
  for(int i=1;i<n-1;i++) //casillas no extremas de la primera fila
    B[i]=(A[i-1]+A[i]+A[i+1]+A[i+n])/5;
  B[n-1]=(A[n-2]+A[n-1]+A[2*n-1])/5; //casilla superior-derecha
  for(int i=1;i<n-1;i++) //para el resto de filas menos la última
    filapar(n,&A[i*n],&B[i*n]);
  B[(n-1)*n]=(A[(n-1)*n-n]+A[(n-1)*n]+A[(n-1)*n+1])/5; //casilla inferior-izquierda
  for(int i=1;i<n-1;i++) //casillas no extremas de la última fila
    B[(n-1)*n+i]=(A[(n-1)*n+i-n]+A[(n-1)*n+i-1]+A[(n-1)*n+i]+A[(n-1)*n+i+1])/5;
  B[(n-1)*n+n-1]=(A[(n-1)*n-1]+A[(n-1)*n+n-2]+A[(n-1)*n+n-1])/5; //casilla inferior-derecha
}

void impar(int n,int *A,int *B)
{
  B[0]=(A[0]+A[n+1])/5; //casilla superior-izquierda
  for(int i=1;i<n-1;i++) //casillas no extremas de la primera fila
    B[i]=(A[n+i-1]+A[i]+A[n+i+1])/5;
  B[n-1]=(A[2*n-2]+A[n-1])/5; //casilla superior-derecha
  for(int i=1;i<n-1;i++) //para el resto de filas menos la última
    filaimpar(n,&A[i*n],&B[i*n]);
  B[(n-1)*n]=(A[(n-1)*n]+A[(n-1)*n-n+1])/5; //casilla inferior-izquierda
  for(int i=1;i<n-1;i++) //casillas no extremas de la última fila
    B[(n-1)*n+i]=(A[(n-1)*n+i-n-1]+A[(n-1)*n+i]+A[(n-1)*n+i-n+1])/5;
  B[(n-1)*n+n-1]=(A[(n-1)*n-2]+A[(n-1)*n+n-1])/5; //casilla inferior-derecha
}

void copiar(int *vo,int n,int *vd)
{
  for(int i=0;i<n;i++)
    vd[i]=vo[i];
}

void  sec(int n,int *A,int numiter,int nodo,int np)
{
  int *B=new int[n*n];
  int numiter2=numiter/2;
  for (int i = 0; i <numiter2; i++)
  {
    par(n,A,B);
#ifdef DEBUG
  escribir(B,n,n);
#endif
    impar(n,B,A);
#ifdef DEBUG
  escribir(A,n,n);
#endif
  }
  if(numiter2*2!=numiter)
  {
    par(n,A,B);
#ifdef DEBUG
  escribir(B,n,n);
#endif
    copiar(B,n*n,A);
  }
#ifdef DEBUG
  escribir(A,n,n);
#endif
  delete[] B;
}

