/*
  CPP_CONTEST=2018Enero
  CPP_PROBLEM=D
  CPP_LANG=CPP+OPENMP
  CPP_PROCESSES_PER_NODE=calisto 1
*/

#include <stdlib.h>
#include <omp.h>

#define NUMTHRE 4

extern void escribir(double *,int,int);

void multiplicar(int n,int ld,double *a,double *r)
{
  for(int i=0;i < n;i++)
  {
    for(int j=0;j < n;j++)
    {
      double s=r[i*ld+j];
      for(int k=0;k < n;k++)
      {
        s+=a[i*ld+k]*a[k*ld+j];
      }
      r[i*ld+j]=s;
    }
  }
}

void copiar(double *vo,int n,double *vd)
{
  for(int i=0;i<n;i++)
    vd[i]=vo[i];
}

void sumar(double *vo,int n,double *vd)
{
  for(int i=0;i<n;i++)
    vd[i]+=vo[i];
}

void  sec(int n,double *A)
{
  int i;
  omp_set_num_threads(NUMTHRE);
  double *R=new double[n*n*NUMTHRE];
  for(int i=0;i < n*n*NUMTHRE;i++)
    R[i]=0.;

#pragma omp parallel private(i) 
{
  int hilo=omp_get_thread_num();
  for (i = hilo; i < n; i+=NUMTHRE)
  {
    multiplicar(i+1,n,A,&R[n*n*hilo]);
  }
}
  copiar(R,n*n,A);
  for(int i=1;i<NUMTHRE;i++)
    sumar(&R[n*n*i],n*n,A);
#ifdef DEBUG
  escribir(R,n,n);
#endif
  delete[] R;
}

