/*
  CPP_CONTEST=2018Enero
  CPP_PROBLEM=E
  CPP_LANG=CPP+MPI
  CPP_PROCESSES_PER_NODE=calisto 4
*/

#include <stdlib.h>
#include <mpi.h>
#include <iostream>

using namespace std;

extern void escribir(double *,int,int);

void multiplicar(int n,int ld,double *a,double *r)
{
  for(int i=0;i < n;i++)
  {
    for(int j=0;j < n;j++)
    {
      double s=r[i*ld+j];
      for(int k=0;k < n;k++)
      {
        s+=a[i*ld+k]*a[k*ld+j];
      }
      r[i*ld+j]=s;
    }
  }
}

void copiar(double *vo,int n,double *vd)
{
  for(int i=0;i < n;i++)
    vd[i]=vo[i];
}

void sumar(double *vo,int n,double *vd)
{
  for(int i=0;i<n;i++)
    vd[i]+=vo[i];
}

void  sec(int n,double *A,int nodo,int np)
{
  MPI_Status *status;
  MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD);
  if(nodo!=0)
    A=new double[n*n]; //para almacenar la matriz localmente
  double *R=new double[n*n]; //para los resultados parciales, y el total en el proceso 0
  for(int i=0;i < n*n;i++)
    R[i]=0.;
  MPI_Bcast(A,n*n,MPI_DOUBLE,0,MPI_COMM_WORLD); //se envía la matriz a todos
//  cout <<"proceso "<<nodo<<" recibe matriz"<<endl;
  for (int i = nodo; i < n; i+=np) //y cada uno calcula una parte
  {
    multiplicar(i+1,n,A,R);
  }
  if(nodo==0)
  {  
     copiar(R,n*n,A); //copia su resultado parcial a la solución
     for(int i=1;i<np;i++)
     {
        MPI_Recv(R,n*n,MPI_DOUBLE,i,10,MPI_COMM_WORLD,status); //recibe resultados parciales
        sumar(R,n*n,A); //y acumula sobre el resultado final
     }
  }
  else
     MPI_Send(R,n*n,MPI_DOUBLE,0,10,MPI_COMM_WORLD);         
#ifdef DEBUG
  escribir(R,n,n);
#endif
  if(nodo!=0)
    delete[] A;
  delete[] R;
}
